function SOAPResponseMauer(URL, headers, body) {
  this.from = URL;
  this.to = "undefined";

  if(headers)
    this.headers = headers;
  else
    this.headers = "";
  this.body = body;
}

// get source
SOAPResponseMauer.prototype.encode = function() {
  return this.headers + "\r\n" + this.body;
}

// display response
SOAPResponseMauer.prototype.decode = function(dbody) {

  // remove all child nodes
  while(dbody.firstChild)
    dbody.removeChild(dbody.firstChild);

  var message = this.headers + "\r\n" + this.body;
  var dom = new DOMParser().parseFromString(this.body, "text/xml");
  // print the name of the root element or error message
  if(dom.documentElement.nodeName == "parsererror")
    throw "error while parsing";

  var envelope = dom.documentElement;
  this._decodeNode(dbody, envelope);

  //dbody.appendChild(document.createTextNode(this.body));

}

SOAPResponseMauer.prototype._decodeNode = function(block, root) {
  for(var si = root.firstChild; si != null; si = si.nextSibling) {
    if(si.nodeType == 3 || si.nodeType == 4) { // TEXT_NODE or CDATA_SECTION_NODE
      var div = document.createElementNS("http://www.w3.org/1999/xhtml", "span");
      div.setAttribute("class", "xmlTextNode");
      div.appendChild(document.createTextNode(si.nodeValue));
      block.appendChild(div);
    }
    else if(si.nodeType == 1) { // ELEMENT_NODE
      var div = document.createElementNS("http://www.w3.org/1999/xhtml", "div");
      div.setAttribute("class", "xmlElementNode");
      div.appendChild(document.createTextNode(si.localName));
      this._decodeNode(div, si);
      block.appendChild(div);
    }
    else if(si.nodeType == 2) { // ATTRIBUTE_NODE
      var div = document.createElementNS("http://www.w3.org/1999/xhtml", "div");
      div.setAttribute("class", "xmlAttributeNode");
      div.appendChild(document.createTextNode(si.nodeValue));
      block.appendChild(div);
    }
  }

}
